// XZR2 t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i,diskid=0;

	// Ff[^ (Disk)
	struct fpos vd1[] =
	{
		{ 0x28, 0x01, 0x0000, 0x0200 },	// 00
		{ 0x28, 0x02, 0x0000, 0x0200 },	// 01
		{ 0x28, 0x03, 0x0000, 0x0200 },	// 02
		{ 0x28, 0x03, 0x0200, 0x0200 },	// 03
		{ 0x28, 0x04, 0x0000, 0x0200 },	// 04
		{ 0x28, 0x04, 0x0200, 0x0200 },	// 05
		{ 0x28, 0x05, 0x0000, 0x0200 },	// 06
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};

	// OPNApf[^ (Disk A)
	struct fpos ma1[] =
	{
		{ 0x0e, 0x02, 0x0000, 0x0200 },	// xNg̗JT
		{ 0x04, 0x05, 0x0000, 0x0600 },	// Q̐_b
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};

	// OPNpf[^ (Disk A)
	struct fpos mb1[] =
	{
		{ 0x2c, 0x05, 0x0000, 0x0200 },	// xNg̗JT
		{ 0x01, 0x02, 0x0000, 0x0500 },	// Q̐_b
		{ 0x2c, 0x01, 0x0000, 0x0100 },	// 
		{ 0x2d, 0x04, 0x0000, 0x0200 },	// 
		{ 0x2a, 0x05, 0x0000, 0x0300 },	// 
		{ 0x2b, 0x03, 0x0000, 0x0200 },	// 
		{ 0x2d, 0x02, 0x0000, 0x0200 },	// 
		{ 0x2c, 0x03, 0x0000, 0x0200 },	// 
		{ 0x31, 0x03, 0x0000, 0x0200 },	// 
		{ 0x2a, 0x01, 0x0000, 0x0200 },	// 
		{ 0x29, 0x02, 0x0000, 0x0200 },	// 
		{ 0x29, 0x04, 0x0000, 0x0200 },	// 
		{ 0x2a, 0x03, 0x0000, 0x0200 },	// 
		{ 0x2e, 0x02, 0x0000, 0x0200 },	// 
		{ 0x2e, 0x04, 0x0000, 0x0100 },	// 
		{ 0x2f, 0x02, 0x0000, 0x0100 },	// 
		{ 0x2e, 0x05, 0x0000, 0x0100 },	// 
		{ 0x02, 0x02, 0x0000, 0x0200 },	// 
		{ 0x2e, 0x01, 0x0000, 0x0100 },	// 
		{ 0x2f, 0x05, 0x0000, 0x0100 },	// 
		{ 0x2f, 0x01, 0x0000, 0x0100 },	// 
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};

	// OPNApf[^ (Disk B)
	struct fpos ma2[] =
	{
		{ 0x2d, 0x02, 0x0000, 0x0200 },	// Gs[O
		{ 0x2f, 0x02, 0x0000, 0x0800 },	// E҂̕
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};
	// OPNpf[^ (Disk B)
	struct fpos mb2[] =
	{
		{ 0x2c, 0x05, 0x0000, 0x0200 },	// Gs[O
		{ 0x2d, 0x05, 0x0000, 0x0700 },	// E҂̕
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x05);
		disk.ReadDATA1(0x4f, 0x27, 0x01, 0x05, 0x03, buff, 1);
		diskid = *buff;

		if (diskid>4) continue;		// ႤfBXN
		printf("Disk %c F܂.\n",'A'+diskid);

		switch (diskid)
		{
		case 0x00:	//Disk A
			fcut("DRIVER",  0x30, 0x18, 0x00, 0x01, 0x03, 0x0000, 0x1c00);
			// OPNApf[^̐؂o
			for (i=0; ma1[i].trk; i++)
			{
				sprintf(fname,"MA%1d%02d",diskid,i);
				fcut(fname, ma1[i].trk, ma1[i].trk>>1, ma1[i].trk&1, ma1[i].sec, 0x03, ma1[i].ofs, ma1[i].size*4);
			}
			// OPNpf[^̐؂o
			for (i=0; mb1[i].trk; i++)
			{
				sprintf(fname,"MB%1d%02d",diskid,i);
				fcut(fname, mb1[i].trk, mb1[i].trk>>1, mb1[i].trk&1, mb1[i].sec, 0x03, mb1[i].ofs, mb1[i].size*4);
			}
			// Ff[^̐؂o
			for (i=0; vd1[i].trk; i++)
			{
				sprintf(fname,"VD%1d%02d",diskid,i);
				fcut(fname, vd1[i].trk, vd1[i].trk>>1, vd1[i].trk&1, vd1[i].sec, 0x03, vd1[i].ofs, vd1[i].size);
			}
			continue;

		case 0x01:	//Disk B
			// OPNApf[^̐؂o
			for (i=0; ma2[i].trk; i++)
			{
				sprintf(fname,"MA%1d%02d",diskid,i);
				fcut(fname, ma2[i].trk, ma2[i].trk>>1, ma2[i].trk&1, ma2[i].sec, 0x03, ma2[i].ofs, ma2[i].size*4);
			}
			// OPNpf[^̐؂o
			for (i=0; mb2[i].trk; i++)
			{
				sprintf(fname,"MB%1d%02d",diskid,i);
				fcut(fname, mb2[i].trk, mb2[i].trk>>1, mb2[i].trk&1, mb2[i].sec, 0x03, mb2[i].ofs, mb2[i].size*4);
			}
			continue;
		}
	}
	return 0;
}

